{
This component was created by Ido Kanner. Email: ik_5@hotmail.com
 I publish this component under the GNU licence (http://www.gnu.org/licenses/gpl.html).

 I also request that any bug fixing or additional code that you publish on your own, please
 send me a copy of that code.

 History:
  9/5/03 - This unit was created.
}
{$IFDEF Linux}
 This Component does not support linux or kylix !!!
{$ENDIF}
{$i Compilers.inc} 
unit RegLanguageChanger;

interface
uses SysUtils, Classes,
     {$ifdef COMPILER_6_UP}
       DesignIntf, DesignEditors,
     {$else}
        DsgnIntf,
     {$endif}
      LanguageChanger;

type
 TIDProperty = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValues(Proc: TGetStrProc); override;
  end;

 TLocolizedProperty = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValues(Proc: TGetStrProc); override;
  end;

 TEnglishProperty = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValues(Proc: TGetStrProc); override;
  end;

 TShortProperty = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValues(Proc: TGetStrProc); override;
  end;

  TNativeProperty = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValues(Proc: TGetStrProc); override;
  end;

 TExtentionProperty = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValues(Proc: TGetStrProc); override;
  end;

procedure Register;

implementation

// TIDProperty \\

function TIDProperty.GetAttributes: TPropertyAttributes;
begin
  Result := inherited GetAttributes + [paValueList{, paAutoUpdate}] - [paMultiSelect,
    paSubProperties];
end;

procedure TIDProperty.GetValues(Proc: TGetStrProc);
var
  i    : integer;
begin
  for i := 0 to MaxLanguaes-1 do
   if Trim(IntToHex(LanguagesList[i].intILANGUAGE,4)) <> '0000' then
     Proc(IntToHex(LanguagesList[i].intILANGUAGE,4));
end;

// TLocolizedProperty \\

function TLocolizedProperty.GetAttributes: TPropertyAttributes;
begin
  Result := inherited GetAttributes + [paValueList{, paAutoUpdate}] - [paMultiSelect,
    paSubProperties];
end;

procedure TLocolizedProperty.GetValues(Proc: TGetStrProc);
var
  i: integer;
begin
  for i := 0 to MaxLanguaes-1 do
   if (Trim(LanguagesList[i].strSLANGUAGE)<>'') then
     Proc(LanguagesList[i].strSLANGUAGE);
end;

// TEnglishProperty \\

function TEnglishProperty.GetAttributes: TPropertyAttributes;
begin
  Result := inherited GetAttributes + [paValueList{, paAutoUpdate}] - [paMultiSelect,
    paSubProperties];
end;

procedure TEnglishProperty.GetValues(Proc: TGetStrProc);
var
  i: integer;
begin
  for i := 0 to MaxLanguaes-1 do
   if (Trim(LanguagesList[i].strSENGLANGUAGE)<>'') then
     Proc(LanguagesList[i].strSENGLANGUAGE);
end;

// TShortProperty \\

function TShortProperty.GetAttributes: TPropertyAttributes;
begin
  Result := inherited GetAttributes + [paValueList{, paAutoUpdate}] - [paMultiSelect,
    paSubProperties];
end;

procedure TShortProperty.GetValues(Proc: TGetStrProc);
var
  i: integer;
begin
  for i := 0 to MaxLanguaes-1 do
   if (Trim(LanguagesList[i].strSABBREVLANGNAME)<>'') then
     Proc(LanguagesList[i].strSABBREVLANGNAME);
end;

// TNativeProperty \\

function TNativeProperty.GetAttributes: TPropertyAttributes;
begin
  Result := inherited GetAttributes + [paValueList{, paAutoUpdate}] - [paMultiSelect,
    paSubProperties];
end;

procedure TNativeProperty.GetValues(Proc: TGetStrProc);
var
  i: integer;
begin
  for i := 0 to MaxLanguaes-1 do
   if (Trim(LanguagesList[i].strSNATIVELANGNAME)<>'') then
     Proc(LanguagesList[i].strSNATIVELANGNAME);
end;

// TExtentionProperty \\

function TExtentionProperty.GetAttributes: TPropertyAttributes;
begin
  Result := inherited GetAttributes + [paValueList{, paAutoUpdate}] - [paMultiSelect,
    paSubProperties];
end;

procedure TExtentionProperty.GetValues(Proc: TGetStrProc);
var
  i: integer;
begin
  for i := 0 to MaxLanguaes-1 do
   if (Trim(LanguagesList[i].strExtention) <>'') then
     Proc(LanguagesList[i].strExtention);
end;

procedure Register;
begin
 RegisterPropertyEditor(TypeInfo(string), TCurrentLanguages, 'LayoutID'            , TIDProperty);
 RegisterPropertyEditor(TypeInfo(string), TCurrentLanguages, 'LayoutLocolizedName' , TLocolizedProperty);
 RegisterPropertyEditor(TypeInfo(string), TCurrentLanguages, 'LayoutEnglishName'   , TEnglishProperty);
 RegisterPropertyEditor(TypeInfo(string), TCurrentLanguages, 'LayoutShortName'     , TShortProperty);
 RegisterPropertyEditor(TypeInfo(string), TCurrentLanguages, 'LayoutNativeName'    , TNativeProperty);
 RegisterPropertyEditor(TypeInfo(string), TCurrentLanguages, 'LayoutExtention'     , TExtentionProperty);


 RegisterComponents('IK - NOT Visual', [TCurrentLanguages]);
end;

end.
